with Bytes, Flts;
use Bytes, Flts;

pragma Elaborate_All (Bytes,Flts);

generic

package Big_Numbers.Signed.NDRs is

  type NDR is record         -- represents (Num/Den)*Sqrt(Root)
    Num: Big_Integer;
    Den, Root: Big_Natural;
  end record;

  function Approx(N: Big_Natural) return Flt;
  function Approx(I: Big_Integer) return Flt;
  procedure Show1(St: in String; N: in Big_Natural; NewLine: in Boolean := True);
  procedure Show1(St: in String; I: in Big_Integer; NewLine: in Boolean := True);
  procedure Show1(St: in String; S: in NDR; NewLine: in Boolean := True);
  procedure Put(F: in Byte_File_Type; S: in NDR);
  procedure Get(F: in Byte_File_Type; S: out NDR);

end Big_Numbers.Signed.NDRs;
