
generic

package Big_Numbers.Signed is

  type Big_Integer is record
    Neg_Sign: Boolean := False;
    Number: Big_Natural := Big_NZero;
  end record;

  procedure Assign(I1: in Integer; I2: out Big_Integer);
  function IBig(I: Integer) return Big_Integer;
  function Sign(I: Big_Integer) return Integer;
  function Compare(I1,I2: Big_Integer) return Integer;  -- sign of I1-I2
  procedure Neg(I: in out Big_Integer);
  function "-"(I: Big_Integer) return Big_Integer;
  procedure Add(N: in Big_Natural; I: in out Big_Integer);
  function "+"(N: Big_Natural; I: Big_Integer) return Big_Integer;
  procedure Add(I1: in Big_Integer; I2: in out Big_Integer);
  function "+"(I1,I2: Big_Integer) return Big_Integer;
  procedure Sub(N: in Big_Natural; I: in out Big_Integer);
  function "-"(N: Big_Natural; I: Big_Integer) return Big_Integer;
  procedure Sub(I1: in Big_Integer; I2: in out Big_Integer);
  function "-"(I1,I2: Big_Integer) return Big_Integer;
  procedure Mult(I1: in Integer; I2: in out Big_Integer);
  function "*"(I1: Integer; I2: Big_Integer) return Big_Integer;
  procedure Prod(N: in Big_Natural; I1: in Big_Integer; I2: out Big_Integer);
  function "*"(N: Big_Natural; I: Big_Integer) return Big_Integer;
  procedure Prod(I1,I2: in Big_Integer; I3: out Big_Integer);
  function "*"(I1,I2: Big_Integer) return Big_Integer;
  procedure Power(J: in Integer; P: in Natural; I: out Big_Integer);
  function "**"(J: Integer; P: Natural) return Big_Integer;
  procedure Power(I1: in Big_Integer; P: in Natural; I2: out Big_Integer);
  function "**"(I: Big_Integer; P: Natural) return Big_Integer;
  procedure Div(J: in Integer; I: in out Big_Integer; R: out Integer);
  function "/"(I: Big_Integer; J: Integer) return Big_Integer;
  function "rem"(I: Big_Integer; J: Integer) return Integer;
  procedure Div(I1,I2: in Big_Integer; IQ,IR: out Big_Integer);
  function "/"(I1,I2: Big_Integer) return Big_Integer;
  function "rem"(I1,I2: Big_Integer) return Big_Integer;

  pragma Inline_Always (Assign,IBig,Sign);

  Big_IZero: constant Big_Integer := (False,Big_NZero);
  Big_IOne: constant Big_Integer := (False,Big_NOne);

  function Strng(I: Big_Integer; Base: Bases := 10) return String;
  function Value(S: in String; Base: Bases := 10) return Big_Integer;

private

  procedure Neg(Num: in Big_Natural; Neg_Sign: in out Boolean);

  pragma Inline_Always (Neg);

end Big_Numbers.Signed;
