
package body Bytes is

  procedure Create(F: in out Byte_File_Type; Name: in String) is
  begin
    Byte_IO.Create(F,Byte_IO.Out_File,Name);
  end Create;

  procedure Open(F: in out Byte_File_Type; Name: in String) is
  begin
    Byte_IO.Open(F,Byte_IO.In_File,Name);
  end Open;

  procedure Put(F: in Byte_File_Type; V: in Byte_Vec) is
  begin
    for I in V'Range loop
      Byte_IO.Write(F,V(I));
    end loop;
  end Put;

  procedure Put(F: in Byte_File_Type; N: in Natural; NLast: in Nat3) is
    M: Natural := N;
  begin
    for L in 0 .. NLast loop
      Put(F,Byte(M mod 256));
      M := M/256;
    end loop;
    if M /= 0 then raise Numeric_Error; end if;
  end Put;

  procedure Get(F: in Byte_File_Type; V: out Byte_Vec) is
  begin
    for I in V'Range loop
      Byte_IO.Read(F,V(I));
    end loop;
  end Get;

  procedure Get(F: in Byte_File_Type; N: out Natural; NLast: in Nat3) is
    B: Byte;
    Fac: Natural := 1;
  begin
    Get(F,B);
    N := Natural(B);
    for L in 1 .. NLast loop
      Get(F,B);
      Fac := 256*Fac;
      N := N+Fac*Natural(B);
    end loop;
  end Get;

end Bytes;
