with Interfaces, Ada.Sequential_IO;
use Interfaces;

pragma Elaborate_All (Interfaces,Ada.Sequential_IO);

package Bytes is

  subtype Byte is Unsigned_8;
  type Byte_Vec is array (Natural range <>) of Byte;

  package Byte_IO is new Ada.Sequential_IO(Byte);

  subtype Byte_File_Type is Byte_IO.File_Type;
  subtype Nat3 is Integer range 0 .. 3;

  procedure Create(F: in out Byte_File_Type; Name: in String);
  procedure Open(F: in out Byte_File_Type; Name: in String);
  procedure Close(F: in out Byte_File_Type) renames Byte_IO.Close;
  function End_Of_File(File: in Byte_File_Type) return Boolean renames Byte_IO.End_Of_File;

  procedure Put(F: in Byte_File_Type; B: in Byte) renames Byte_IO.Write;
  procedure Put(F: in Byte_File_Type; V: in Byte_Vec);
  procedure Put(F: in Byte_File_Type; N: in Natural; NLast: in Nat3);

  procedure Get(F: in Byte_File_Type; B: out Byte) renames Byte_IO.Read;
  procedure Get(F: in Byte_File_Type; V: out Byte_Vec);
  procedure Get(F: in Byte_File_Type; N: out Natural; NLast: in Nat3);

  --- NLast+1 is number of bytes used to store N

end Bytes;
