with BigRats, Regges, Flts;
use Flts;

pragma Elaborate_All (BigRats,Regges,Flts);

generic

  LMax: in Positive;

  type Scalar is private;

  with procedure Neg(S: in out Scalar) is <>;
  with procedure Add(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Sub(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Mult(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Div(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Assign(K: in Integer; S: in out Scalar) is <>;
  with procedure Assign(R: in Flt; S: in out Scalar) is <>;
  with procedure Mult(R: in Flt; S,Tmp: in out Scalar) is <>;
  with procedure IPower(I: in Integer; S1: in Scalar; S2,Tmp: in out Scalar) is <>;
  with procedure Sqrt(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Show1(N: in String; S: in Scalar; NewLine: in Boolean := True) is <>;

package CG is

  NMax: constant Positive := 3*LMax+1;

  package CGB is new BigRats (NMax => NMax);
  package CGR is new Regges (LMax => LMax);
  use CGB, CGR;

  subtype Int_Scalar is Scalar;

  Factorial: constant Factorial_Type := Make_Factorials;

  procedure Num_Mult(B: in BigRat; S,Tmp3,Tmp4,Tmp5: in out Int_Scalar);
  procedure Den_Mult(B: in BigRat; S,Tmp3,Tmp4,Tmp5: in out Int_Scalar);

  --- R is not checked for consistency
  procedure IntSymRegge(R: in Regge; SNum,SDen,SRoot,Tmp3,Tmp4,Tmp5: in out Int_Scalar);
  procedure SymRegge(R: in Regge; S,Tmp1,Tmp2,Tmp3,Tmp4,Tmp5: in out Scalar);
  procedure SymRegge(R: in Regge; S: in out Scalar);
  procedure SqrSymRegge(R: in Regge; S,Tmp1,Tmp2,Tmp3,Tmp4,Tmp5: in out Scalar);
  procedure SqrSymRegge(R: in Regge; S: in out Scalar);

  procedure IntSym3j(N1,N2,N3: in Natural; M1,M2,M3: in Integer; SNum,SDen,SRoot,Tmp3,Tmp4,Tmp5: in out Int_Scalar);
  procedure Sym3j(N1,N2,N3: in Natural; M1,M2,M3: in Integer; S,Tmp1,Tmp2,Tmp3,Tmp4,Tmp5: in out Scalar);
  procedure Sym3j(N1,N2,N3: in Natural; M1,M2,M3: in Integer; S: in out Scalar);
  procedure SqrSym3j(N1,N2,N3: in Natural; M1,M2,M3: in Integer; S,Tmp1,Tmp2,Tmp3,Tmp4,Tmp5: in out Scalar);
  procedure SqrSym3j(N1,N2,N3: in Natural; M1,M2,M3: in Integer; S: in out Scalar);

  procedure ShowSym3j(N1,N2,N3: in Natural; M1,M2,M3: in Integer);
  procedure ShowRegges(MaxL: in Natural; Values: in Boolean := False);

private

  IntegerLast: constant Flt := Two**64;

end CG;
