with Ints, Flts, Globals, Reps, Reps.Balls, Params;
use Ints, Flts, Globals, Reps.Balls, Params;
with Matrices, Vectors, ScalVectors, CG, CG.Zerni, Zernikes, Zernikes.GFix;

pragma Elaborate_All (Ints,Flts,Globals,Reps.Balls,Params);
pragma Elaborate_All (Matrices,Vectors,ScalVectors,CG.Zerni,Zernikes.GFix);

procedure Check_Fixpt is

  NT: constant Positive := GetArg;
  Sol: constant Natural := GetArg;

  P: Param renames PList(Sol);
  Par: Parity renames P.Par;
  Size: Positive renames P.Size;
  Rho: Radius renames P.Rho;

  subtype Scalar is Ball;

  package SCG is new CG (LMax => Size, Scalar => Scalar);
  package SCG_Zerni is new SCG.Zerni;
  use SCG_Zerni;
  package SZ is new Zernikes (Size => Size, Scalar => Scalar);
  package SM is new Matrices (Scalar => Scalar);
  package SV is new Vectors (Component => Scalar);
  package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);
  package SZF is new SZ.GFix(Par => Par, Rho => Rho, Mat_PackSize => P.Mat_PackSize,
                             SM => SM, SV => SV, SSV => SSV);
  use SM,SV,SSV,SZ,SZF;

  F0,F: Zernike;
  M: QC_Matrix;

begin
  Show("",P);
  if Par=1 then raise Parity_Error; end if;
  Verbosity := 2;
  NTasks := NT;
  Initialize_CGS;

  Read(Input_Dir & Mat_Name(P),M);
  Read(Input_Dir & ApproxFix_Name(P,False),F0);
  NumTrunc(Size,F0,F);
  F.R := Rho;

  ContrFix(Model(P),M,P.Contr_PackSize,F);
  Write(Output_Dir & TrueFix_Name(P,True),F);

end Check_Fixpt;
