with Strings, Ints, Flts, Globals, Reps, Reps.Balls, Params;
use Strings, Ints, Flts, Globals, Reps.Balls, Params;
with Matrices, Vectors, ScalVectors, CG, CG.Zerni, Zernikes, Zernikes.GFix;

pragma Elaborate_All (Strings,Ints,Flts,Globals,Reps.Balls,Params);
pragma Elaborate_All (Matrices,Vectors,ScalVectors,CG.Zerni,Zernikes.GFix);

procedure Check_Index is

  NT: constant Positive := GetArg;
  Sol: constant Natural := GetArg;

  P: Param renames PList(Sol);
  Par: Parity renames P.Par;
  Size: Positive renames P.Size;
  Rho: Radius renames P.Rho;
  NEig: Natural renames P.NEig;
  Eig_PackSize: Positive renames P.Eig_PackSize;

  subtype Scalar is Ball;

  package SCG is new CG (LMax => Size, Scalar => Scalar);
  package SCG_Zerni is new SCG.Zerni;
  use SCG_Zerni;
  package SZ is new Zernikes (Size => Size, Scalar => Scalar);
  package SM is new Matrices (Scalar => Scalar);
  package SV is new Vectors (Component => Scalar);
  package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);
  package SZF is new SZ.GFix(Par => Par, Rho => Rho, Mat_PackSize => P.Mat_PackSize,
                             SM => SM, SV => SV, SSV => SSV);
  use SM,SV,SSV,SZ,SZF;

  S: Scalar;
  F: Zernike;
  D: EData(NEig);

begin
  Show("",P);
  Verbosity := 2;
  NTasks := NT;
  Initialize_CGS;

  Read(Input_Dir & TrueFix_Name(P,False),F);
  MakeWF2(Model(P),F,D.WFF);

  Partial_Read(Input_Dir & EData_Name(P,False),D);
  Complete(Eig_PackSize-2,Model(P),F,D);
  if NEig>1 then
    Show0("KBounds:");
    KBounds(D.WFF,D.U);
  end if;
  MProd_Parallel := True;
  LLMapSpec(D,Eig_PackSize,S);
  Show1("LLBound:",S);

end Check_Index;
