with Ints, Flts, Globals, Reps, Params;
use Ints, Flts, Globals, Reps, Params;
with Matrices, Vectors, ScalVectors, CG, CG.Zerni, Zernikes, Zernikes.GFix;

pragma Elaborate_All (Ints,Flts,Globals,Reps,Params);
pragma Elaborate_All (Matrices,Vectors,ScalVectors,CG.Zerni,Zernikes.GFix);

procedure Find_Eigenv is

  NT: constant Positive := GetArg;
  Sol: constant Natural := GetArg;

  P: Param renames PList(Sol);
  Par: Parity renames P.Par;
  Size: Positive renames P.Size;
  Rho: Radius renames P.Rho;
  NEig: Natural renames P.NEig;

  subtype Scalar is Rep;

  package SCG is new CG (LMax => Size, Scalar => Scalar);
  package SCG_Zerni is new SCG.Zerni;
  use SCG_Zerni;
  package SZ is new Zernikes (Size => Size, Scalar => Scalar);
  package SM is new Matrices (Scalar => Scalar);
  package SV is new Vectors (Component => Scalar);
  package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);
  package SZF is new SZ.GFix(Par => Par, Rho => Rho, Mat_PackSize => P.Mat_PackSize,
                             SM => SM, SV => SV, SSV => SSV);
  use SV,SM,SSV,SZ,SZF;

  F: Zernike;
  D: EData(NEig);

begin
  Show("",P);
  Verbosity := 2;
  PProd_Parallel := True;
  NTasks := NT;
  Initialize_CGS;

  Read(Input_Dir & ApproxFix_Name(P,False),F);
  MakeWF2(Model(P),F,D.WFF);

  Find_Eigen(F,D);

  Partial_Write(Output_Dir & EData_Name(P,True),D);

end Find_Eigenv;
