with Strings;
use Strings;

package body Params is

  procedure Show(N: in String; P: in Param) is
  begin
    Show1(N & "          Hill:",P.Hill);
    Show1(N & "          Ring:",P.Ring);
    Show1(N & "          Symm: ",P.Symm);
    Show1(N & "             F: ",P.F);
    Show1(N & "          Size: ",P.Size);
    Show1(N & "           Par: ",P.Par);
    Show1(N & "           Rho:",P.Rho);
    Show1(N & "  Mat_PackSize: ",P.Mat_PackSize);
    Show1(N & "Contr_PackSize: ",P.Contr_PackSize);
    Show1(N & "          NEig: ",P.NEig);
    Show1(N & "  Eig_PackSize: ",P.Eig_PackSize);
    Show0(N & "        Prefix: " & P.Prefix);
  end Show;

  function Mat_Name(P: Param) return String is
  begin
    return P.Prefix & "-mat." & Strng(P.Mat_PackSize,2);
  end Mat_Name;

  function ApproxFix_Name(P: Param; Include_Size: Boolean := False) return String is
  begin
    if Include_Size then
      return P.Prefix & "-approxfix." & Strng0(P.Size,3);
    else
      return P.Prefix & "-approxfix";
    end if;
  end ApproxFix_Name;

  function TrueFix_Name(P: Param; Include_Size: Boolean := False) return String is
  begin
    if Include_Size then
      return P.Prefix & "-truefix." & Strng0(P.Size,3);
    else
      return P.Prefix & "-truefix";
    end if;
  end TrueFix_Name;

  function EData_Name(P: Param; Include_Size: Boolean := False) return String is
  begin
    if Include_Size then
      return P.Prefix & "-edata." & Strng(P.Par,1) & "." & Strng0(P.Size,3);
    else
      return P.Prefix & "-edata." & Strng(P.Par,1);
    end if;
  end EData_Name;

  function Max_Size(P: Param_List) return Positive is
    Size: Positive := 1;
  begin
    for I in P'Range loop
      Size := IMax(Size,P(I).Size);
    end loop;
    return Size;
  end Max_Size;

end Params;
