with Ada.Text_IO, Flts, Globals, Reps, Params;
use Ada.Text_IO, Flts, Globals, Reps, Params;
with CG, CG.Zerni, Zernikes;

pragma Elaborate_All (Ada.Text_IO,Flts,Globals,Reps,Params);
pragma Elaborate_All (CG.Zerni,Zernikes);

procedure Plot_All is

  Size: constant Positive := 40;

  subtype Scalar is Rep;

  package SCG is new CG (LMax => Size, Scalar => Scalar);
  package SCG_Zerni is new SCG.Zerni;
  use SCG_Zerni;
  package SZ is new Zernikes (Size => Size, Scalar => Scalar);
  use SZ;

  procedure Plot(N: in Positive) is
    P: Param renames PList(N);
    Hill: constant Scalar := Scal(P.Hill);
    Ring: constant Scalar := Scal(P.Ring);
    F: File_Type;
    Z: Zernike;
  begin
    Read(Input_Dir & ApproxFix_Name(P,False),Z);
    Create(F,Out_File,Output_Dir & P.Prefix & ".plot");
    PutPlot(F,-Z);
    Close(F);
    if N=1 then
      SetZero(Z);
      AddHill(Hill,Z);
      AddRing(Ring,Z);
      Add(Scal(1)-Hill-Ring,Z);
      Create(F,Out_File,Output_Dir & "w.plot");
      PutPlot(F,Z);
      Close(F);
    end if;
  end Plot;

begin

  for N in PList'Range loop
    Plot(N);
  end loop;

end Plot_All;
