with Ints, Make_Count;
use Ints;

pragma Elaborate_All (Ints,Make_Count);

generic

  LMax: in Positive;

package Regges is

  I11: constant Integer := 0;
  I12: constant Integer := 1;
  I13: constant Integer := 2;
  I21: constant Integer := 3;
  I22: constant Integer := 4;
  I23: constant Integer := 5;
  I31: constant Integer := 6;
  I32: constant Integer := 7;
  I33: constant Integer := 8;

  subtype Regge is Int_Vec(I11 .. I33); -- represents a 3x3 matrix

  procedure To3j(R: in Regge; N1,N2,N3: out Natural; M1,M2,M3: out Integer);
  procedure ToRegge(N1,N2,N3: in Natural; M1,M2,M3: in Integer; R: out Regge; IsZero: out Boolean);
  function Check(R: Regge) return Boolean;
  procedure Order(R: in out Regge; ChangeSign: out Boolean);

  function Indx(S,B,T,X,L: Natural) return Positive;
  procedure CheckIndx;
  procedure Indx(R: in Regge; I: out Positive; ChangeSign: out Boolean);
  procedure Indx(N1,N2,N3: in Natural; M1,M2,M3: in Integer; I: out Natural; ChangeSign: out Boolean);
  function Indx(N1,N2,N3: Natural; M1,M2,M3: Integer) return Natural;
  procedure OrderedRegge(S,B,T,X,L: in Natural; R: out Regge);

  procedure Show(R: in Regge);
  procedure Show(N1,N2,N3: in Natural; M1,M2,M3: in Integer);
  procedure ShowBoth(R: in Regge);

  LMax1:    constant Positive := LMax+1;
  LMax2:    constant Positive := LMax1*LMax1;
  LST_Count: constant Int_Vec := Make_Count(LMax);
  VSize:    constant Positive := LST_Count(LST_Count'Last);

  Inconsistent: exception;

  pragma Inline_Always (To3j,Check,OrderedRegge);

end Regges;
