with Ada.Text_IO, Ada.Task_Identification, Ada.Task_Attributes;
use Ada, Ada.Text_IO;

pragma Elaborate_All(Ada.Text_IO,Ada.Task_Identification,Ada.Task_Attributes);

package Tasks is --- a leftover from something more useful

  pragma Elaborate_Body;

  type Attribute is
    record
      Level: Natural     := 0;    -- trace level
      Log:   File_Access := null; -- log file, null means Current_Output
    end record;

  Initial_Value: constant Attribute := (Level => 0, Log  => null);
  package Attributes is new Task_Attributes(Attribute,Initial_Value);      -- assign Attributes to tasks

  subtype Task_Id is Ada.Task_Identification.Task_Id;
  subtype Attribute_Handle is Attributes.Attribute_Handle;                 -- access all Attribute

  function Current_Task return Task_Id renames Ada.Task_Identification.Current_Task;                    -- Task_Id for current task
  function Value(ID: Task_Id := Current_Task) return Attribute renames Attributes.Value;                -- Attribute for a task
  function Reference(ID: Task_Id := Current_Task) return Attribute_Handle renames Attributes.Reference; -- Attribute_Handle for a task
  procedure Reinitialize(ID: in Task_Id := Current_Task) renames Attributes.Reinitialize;               -- reset Attribute to Initial_Value

  function Task_Log(H: Attribute_Handle) return File_Access;
  function Task_Log(ID: Task_Id) return File_Access;
  function Task_Log return File_Access;  --- substitutes for Globals.Default_Output

end Tasks;
